package dk.palmoe.immersivexp;

import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.Reader;

import com.google.gson.Gson;
import com.google.gson.stream.JsonWriter;

import org.apache.commons.io.IOUtils;;

public class Config {
    public int logBaseXP = 1;
    public int logRandXP = 2;
    public int cropBaseXP = 1;
    public int cropRandXP = 1;
    public int berriesBaseXP = 0;
    public int berriesRandXP = 1;

    public static final File FILE = new File("config/immersivexp.json");
    public static Config INSTANCE = null;

    public static Config getInstance() {
        if (INSTANCE == null) {
            INSTANCE = new Config().read();
        }
        return INSTANCE;
    }

    private Config read() {
        if (!FILE.exists())
            return new Config().write();

        Reader reader = null;
        try {
            return new Gson().fromJson(reader = new FileReader(FILE), Config.class);
        } catch (Exception e) {
            e.printStackTrace();
            throw new RuntimeException(e);
        } finally {
            IOUtils.closeQuietly(reader);
        }
    }

    private Config write() {
        Gson gson = new Gson();
        JsonWriter writer = null;
        try {
            writer = gson.newJsonWriter(new FileWriter(FILE));
            writer.setIndent("    ");

            gson.toJson(gson.toJsonTree(this, Config.class), writer);
        } catch (Exception e) {
            ImmersiveXP.LOGGER.error("Couldn't save config");
            e.printStackTrace();
            throw new RuntimeException(e);
        } finally {
            IOUtils.closeQuietly(writer);
        }
        return this;
    }
}
