package dk.palmoe.immersivexp;

import net.fabricmc.fabric.api.event.player.PlayerBlockBreakEvents;
import net.fabricmc.fabric.api.event.player.UseBlockCallback;
import net.minecraft.block.BlockState;
import net.minecraft.block.CropBlock;
import net.minecraft.block.MelonBlock;
import net.minecraft.block.SweetBerryBushBlock;
import net.minecraft.server.world.ServerWorld;
import net.minecraft.tag.BlockTags;
import net.minecraft.util.ActionResult;
import net.minecraft.util.Identifier;
import net.minecraft.util.registry.Registry;

public class Events {
    public static void init() {
        PlayerBlockBreakEvents.AFTER.register((world, player, pos, state, entity) -> {
            if (world instanceof ServerWorld) {
                if (state.getBlock() instanceof CropBlock || state.getBlock() instanceof MelonBlock) {
                    Config config = Config.getInstance();
                    Util.spawnXp((ServerWorld) world, pos, config.cropBaseXP, config.cropRandXP);
                }

                if (state.isIn(BlockTags.LOGS)) {
                    boolean holdingAxe = player.isHolding(Registry.ITEM.get(new Identifier("minecraft:axe")));
                    boolean isGrown = Util.isTreeNaturallyGrown(world, pos);

                    if (holdingAxe && isGrown) {
                        Config config = Config.getInstance();
                        Util.spawnXp((ServerWorld) world, pos, config.logBaseXP, config.logRandXP);
                    }
                }
            }
        });

        UseBlockCallback.EVENT.register(((player, world, hand, hitResult) -> {
            BlockState state = world.getBlockState(hitResult.getBlockPos());

            if (state.getBlock() instanceof SweetBerryBushBlock && world instanceof ServerWorld) {
                int age = state.get(SweetBerryBushBlock.AGE);
                if (age == 3) {
                    Config config = Config.getInstance();
                    Util.spawnXp((ServerWorld) world, hitResult.getBlockPos(), config.berriesBaseXP,
                            config.berriesRandXP);
                }

            }

            return ActionResult.PASS;
        }));
    }
}
