package dk.palmoe.immersivexp;

import java.util.LinkedList;
import net.minecraft.block.BlockState;
import net.minecraft.block.LeavesBlock;
import net.minecraft.entity.ExperienceOrbEntity;
import net.minecraft.server.world.ServerWorld;
import net.minecraft.tag.BlockTags;
import net.minecraft.util.math.BlockPos;
import net.minecraft.util.math.Vec3d;
import net.minecraft.world.World;

public class Util {
    public static final int MAX_SEARCH_DEPTH = 100;

    public static boolean isTreeNaturallyGrown(World world, BlockPos pos) {
        LinkedList<BlockPos> queue = new LinkedList<BlockPos>();
        queue.push(pos.up());
        int search_depth = 0;

        while (!queue.isEmpty() && (search_depth <= MAX_SEARCH_DEPTH)) {
            BlockPos nextPos = queue.pop();

            BlockPos[] dirs = { nextPos.north(), nextPos.east(), nextPos.south(), nextPos.west(), nextPos.up() };
            for (BlockPos dir : dirs) {
                BlockState state = world.getBlockState(dir);
                if (state.getBlock() instanceof LeavesBlock && !state.get(LeavesBlock.PERSISTENT)) {
                    return true;
                }

                if (world.getBlockState(dir).isIn(BlockTags.LOGS)) {
                    queue.push(dir);
                }
            }

            search_depth++;
        }

        return false;
    }

    public static void spawnXp(ServerWorld world, BlockPos pos, int min, int cap) {
        Vec3d xp_pos = new Vec3d(pos.getX(), pos.getY(), pos.getZ());
        ExperienceOrbEntity.spawn(world, xp_pos, min + world.random.nextInt(cap));
    }
}
